﻿-- Author      : nnp_home
-- Create Date : 9/3/2012 8:19:25 AM
-- RCLootHistory.lua: Manages the Loot History Frame

RCLootCouncil_LootHistory = RCLootCouncil:NewModule("RCLootHistory")
local selection; -- id of the current selected raid
local lootDB;

--[[ lootDB format:
	lootDB = {			
		"playerName" = {
					[#] = {"lootWon", "date (d/m/y)", "time (h:m:s)", "instance", "boss", "votes", "itemReplaced1", "itemReplaced2", "response", "responseID"}
		},
	}
]]
local lootDBbyRaid = {}; -- same as lootDB, but with playerName and instance swapped

function RCLootCouncil_LootHistory:OnEnable()
	lootDB = RCLootCouncil.db.factionrealm.lootDB -- get the db
	local instanceNum = 0;
	-- extract all the raids from the lootDB
	for k,v in pairs(lootDB) do
		for a,b in pairs(v) do
			b["playerName"] = k;
			if lootDBbyRaid[b["instance"]] then -- if it already exists
				tinsert(lootDBbyRaid[b["instance"]], b)	
			else -- if it doesn't
				lootDBbyRaid[b["instance"]] = {b};
				instanceNum = instanceNum + 1
			end
		end
	end

	local button = CreateFrame("Button", "$parentButton1", RCLootHistoryFrameContent1, "RCLootHistoryRaidButton")
	button:SetID(1)
	button:SetPoint("TOPLEFT", 3, -3)
	button:Show()
	for i = 2, instanceNum do
		local button = CreateFrame("Button", "$parentButton"..i, RCLootHistoryFrameContent1, "RCLootHistoryRaidButton")
		button:SetID(i)
		button:SetPoint("TOP", "$parentButton"..(i-1), "BOTTOM")
		button:Show();
	end
	local i = 1;
	for k,_ in pairs(lootDBbyRaid) do
		getglobal("RCLootHistoryFrameContent1Button"..i):SetText(tostring(k))
		i = i + 1
		if i > instanceNum +1 then break; end
	end

	RCLootHistoryFrame:Show()

	--[[for k,v in pairs(lootDBbyRaid) do
		if type(v) == "table" then
			for a,b in pairs(v) do
				if type(b) == "table" then
					for x,y in pairs(b) do
						if type(y) == "table" then
							for i,j in pairs(y) do
								print("lootDBbyRaid["..k.."]["..a.."]["..x.."]["..i.."]: "..tostring(j))
							end
						else
							print("lootDBbyRaid["..k.."]["..a.."]["..x.."]: "..tostring(y))
						end
					end
				else
					print("lootDBbyRaid["..k.."]["..a.."]: "..tostring(b))
				end
			end
		else
			print("lootDBbyRaid["..k.."]: "..tostring(v))
		end
	end --]]
end

function RCLootCouncil_LootHistory:OnDisable()
	RCLootHistoryFrame:Hide()
end

function RCLootCouncil_LootHistory:ButtonOnClick(name)
	selection = name
	local textToAdd = "";
	for number, content in pairs(lootDBbyRaid[name]) do
		textToAdd = textToAdd.."\n["..number.."] = {";
		textToAdd = textToAdd.."\n"..content["playerName"].." = {";			
		textToAdd = textToAdd.."\nInstance:"..content["instance"];
		textToAdd = textToAdd.."\nBoss:"..content["boss"];
		textToAdd = textToAdd.."\nDate/time:"..content["date"].." "..content["time"];
		textToAdd = textToAdd.."\nItem won:"..content["lootWon"];
		if content["itemReplaced2"] and content["itemReplaced2"] ~= "" then
			textToAdd = textToAdd.."\nReplaced:  "..content["itemReplaced1"].." and/or";
			textToAdd = textToAdd.."\n"..content["itemReplaced2"];
		elseif content["itemReplaced1"] then
			textToAdd = textToAdd.."\nReplaced:"..content["itemReplaced1"];
		end
		textToAdd = textToAdd.."\ntResponse:"..content["response"];
		textToAdd = textToAdd.."\nVotes:"..tostring(content["votes"]);
		textToAdd = textToAdd.."\n}";
	end
	textToAdd = textToAdd.."\n}";
	getglobal("RCLootHistoryFrameContent2"):SetText(textToAdd)
	getglobal("RCLootHistoryFrameContent2"):Show()

end

function RCLootCouncil_LootHistory:ButtonAllOnClick()
	local textToAdd = "";
	for k,v in pairs(lootDBbyRaid) do
		textToAdd = textToAdd.."\n["..k.."] = {";
		for number, content in pairs(v) do
			textToAdd = textToAdd.."\n["..number.."] = {";
			textToAdd = textToAdd.."\n"..content["playerName"].." = {";			
			textToAdd = textToAdd.."\nInstance:"..content["instance"];
			textToAdd = textToAdd.."\nBoss:"..content["boss"];
			textToAdd = textToAdd.."\nDate/time:"..content["date"].." "..content["time"];
			textToAdd = textToAdd.."\nItem won:"..content["lootWon"];
			if content["itemReplaced2"] and content["itemReplaced2"] ~= "" then
				textToAdd = textToAdd.."\nReplaced:  "..content["itemReplaced1"].." and/or";
				textToAdd = textToAdd.."\n"..content["itemReplaced2"];
			elseif content["itemReplaced1"] then
				textToAdd = textToAdd.."\nReplaced:"..content["itemReplaced1"];
			end
			textToAdd = textToAdd.."\ntResponse:"..content["response"];
			textToAdd = textToAdd.."\nVotes:"..tostring(content["votes"]);
			textToAdd = textToAdd.."\n}";
		end
	end
	textToAdd = textToAdd.."\n}\n}";
	getglobal("RCLootHistoryFrameContent2"):SetText(textToAdd)
	getglobal("RCLootHistoryFrameContent2"):Show()
end


function RCLootCouncil_LootHistory.isSelected(id)
	return selection == id;
end

function RCLootCouncil_LootHistory:CloseButtonClick()
	RCLootCouncil:DisableModule("RCLootHistory")
end
